(function() {

    var QWeb = openerp.web.qweb;
    openerp.widgetInstanceAdvancement = null;
    openerp.PayslipAdvancement = {};

    openerp.PayslipAdvancement = openerp.Widget.extend({
        template: 'payslip_add.AdvancementWidget',
        id: undefined,
        uid: undefined,
        row_id_select: undefined,
        row_code_select: undefined,
        hrPayslip: [],
        payslipLine: [],
        salaryRule: [],
        resCompany: [],
        resCurrency: [],
        payslipInput: [],
        accountJournal: [],
        statementLine: [],
        statementAvailable: [],
        /* Config */
        statementConfig: [],
        eiruAccountBankUtatementUtility: [],
        /* init */
        init: function (parent) {
            this._super(parent);
            this.uid = parent.session.uid;
        },
        /* Start */
        start: function () {
            var self = this;
            var addAdvancement = this.$el.find('.add-advancement');
            var editAdvancement = this.$el.find('.edit-advancement');
            var refreshAdvancement = this.$el.find('.refresh-advancement');
            var printAdvancement = this.$el.find('.print-advancement');
            var printCommission = this.$el.find('.print-commission');
            var printHoraExtras = this.$el.find('.print-hora-extras');
            var exportCash = this.$el.find('.export-cash');

            // create
            addAdvancement.click(function() {
                self.fetchAddAdvancement();
            });
            // Edit/ unlink
            editAdvancement.click(function() {
                self.fetchModifyAdvancement();
            });
            // Update
            refreshAdvancement.click(function() {
                self.fetchRecomputeSheet();
            });
            // Imprimir Adelanto
            printAdvancement.click(function() {
                self.fetchPrintAdvancement('ADL', 'Adelanto');
            });
            // Imprimir Comision
            printCommission.click(function() {
                self.fetchPrintAdvancement('CMS', 'Comisión');
            });
            // Hora Extras
            printHoraExtras.click(function() {
                self.fetchPrintAdvancement('HORA_EXTRA', 'Hora Extras');
            });
            exportCash.click(function() {
                self.fetchExportCash();
            });
        },
        /* Actualizar ID */
        updateIdAdvancement: function(id) {
            var self = this;
            self.id = id;
        },
        /* Description: Recargar el Widget */
        reloadLine: function() {
            openerp.parentInstance.reload();
        },
        /* Verificar modulo instalados */
        fetchVerifyModule: function(module) {
            if (!module)
                return [];
            var moduleModule =new openerp.web.Model('ir.module.module');
            var fields = ['id', 'name', 'state'];
            var domain = [['name', '=', module], ['state', '=', 'installed']];
            return moduleModule.query(fields).filter(domain).all();
        },
        /* statement Config */
        fetchStatementConfig: function() {
            var self = this;
            if (!self.eiruAccountBankUtatementUtility.length)
                return [];

            var fields = ['id','name', 'active', 'import_statement_payslip', 'import_statement_payslip'];
            var domain = [['active', '=', true]];
            var statementConfig = new openerp.web.Model('account.bank.statement.config');
            return statementConfig.query(fields).filter(domain).all();
        },
        /* Description: Función para recalcular las faltas */
        recomputeSheet: function() {
             var self = this;
             var recomputePayslip = new openerp.web.Model('hr.payslip');
             return recomputePayslip.call('recompute_sheet',[ self.id ], {
                     context: new openerp.web.CompoundContext()
             });
         },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Description: Consultar Compania*/
        fetchResCompany: function () {
            var resComapy = new openerp.web.Model('res.company');
            return resComapy.query(['id','name', 'currency_id']).filter([['id', '=', 1]]).all();
        },
        /* Description: Consultat Moneda Activas */
        fetchResCurrecy : function() {
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var resCurrecy = new openerp.web.Model('res.currency');
            return resCurrecy.query(fields).filter(domain).all();
        },
        /* Get statement Available*/
        fetchStatementAvailable: function() {
            var self = this;
            var statementAvailable = new openerp.web.Model('hr.payslip');
            return statementAvailable.call('get_statement_available',{
                    context: new openerp.web.CompoundContext()
            });
        },
        /* Description: Filtar moneda de la compania */
        getCurrencyCompany: function(id) {
            var self = this;
            return _.filter(self.resCurrency, function(item) {
                return item.id === id;
            });
         },
         /* GET statement JournalId*/
         getStatementeJournal: function(journalId) {
             var self = this;
             return _.filter(self.statementAvailable, function(item){
                 return item.journalID === journalId;
             });
         },
        /* Description: destroy objects*/
        destroyObjects: function() {
            var self = this;
            self.row_id_select = undefined;
            self.row_code_select = undefined;
            self.hrPayslip = [];
            self.payslipLine = [];
            self.salaryRule = [];
            self.resCompany = [];
            self.resCurrency = [];
            self.payslipInput =[];
        },

        /*******************************************************************************************
        Crear Adealnto / comision de Funcionario
             _       _            _       _               ____                _     _
            / \   __| | ___  __ _| |_ __ | |_ ___        / ___|___  _ __ ___ (_)___(_) ___  _ __
           / _ \ / _` |/ _ \/ _` | | '_ \| __/ _ \ _____| |   / _ \| '_ ` _ \| / __| |/ _ \| '_ \
          / ___ \ (_| |  __/ (_| | | | | | || (_) |_____| |__| (_) | | | | | | \__ \ | (_) | | | |
         /_/   \_\__,_|\___|\__,_|_|_| |_|\__\___/       \____\___/|_| |_| |_|_|___/_|\___/|_| |_|
        ********************************************************************************************/
        fetchAddAdvancement: function() {
            var self = this;
            self.fetchPayslip().then(function(hrPayslip) {
                return hrPayslip;
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchPayslipLine();
            }).then(function(payslipLine) {
                self.payslipLine = payslipLine;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.fetchJournal();
            }).then(function(accountJournal) {
                self.accountJournal = accountJournal;
                return self.fetchVerifyModule('eiru_account_bank_statement_utility');
            }).then(function(eiruAccountBankUtatementUtility) {
                self.eiruAccountBankUtatementUtility= eiruAccountBankUtatementUtility;
                return self.fetchStatementConfig();
            }).then(function(statementConfig) {
                self.statementConfig= statementConfig;
                return self.fetchStatementAvailable();
            }).then(function(statementAvailable) {
                self.statementAvailable = statementAvailable;
                return self.showPayslipAddAdvancement();
            }).then(function() {
                return self.recomputeSheet();
            }).then(function() {
                return self.reloadLine();
            }).then(function() {
                return self.destroyObjects();
            });
        },
        /* Description : Consultar Payslip */
        fetchPayslip: function() {
            var self = this;
            var payslip = new openerp.web.Model('hr.payslip');
            return payslip.query(['name', 'employee_id', 'number','date_from','date_to']).filter([['id', '=', self.id]]).all();
        },
        /* Description: Consultar payslip Line (hr.payslip.line) */
        fetchPayslipLine: function() {
            var self = this;
            var fields = ['id', 'name', 'code', 'slip_id', 'amount', 'employee_id'];
            var domain = [['code', '=', 'NET'],['slip_id', '=', self.id]];
            var payslipLine = new openerp.web.Model('hr.payslip.line');
            return payslipLine.query(fields).filter(domain).all();
        },
        /* Description: Consulta Reglas Salarial (ADL CMS)*/
        fetchSalaryRule: function() {
            var salaryRule = new openerp.web.Model('hr.salary.rule');
            return salaryRule.query(['name','code']).filter([['code','in',['ADL','CMS', 'HORA_EXTRA']]]).all();
        },
        /* Consultar método de pagos */
        fetchJournal: function() {
            var fields = ['id', 'name', 'code', 'type', 'currency', 'default_debit_account_id', 'default_credit_account_id'];
            var domain = [['active', '=', true], ['type', 'in', ['bank', 'cash']], ['currency', '=', false]];
            var journalSalario = new openerp.web.Model('account.journal');
            return journalSalario.query(fields).filter(domain).all();
        },
        /* Description: Modal crear Adealnto/ comision de Funcionario */
        showPayslipAddAdvancement: function() {
            var self = this;
            var defer = $.Deferred()
            var results = true;
            var payslipLine = self.payslipLine[0];
            var hrPayslip = self.hrPayslip[0];
            var company = self.resCompany[0];
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();
            var amount_Adl = 0;
            var salaryRule = self.salaryRule;
            var journal = self.accountJournal;

            if (!!salaryRule){
                salaryRule.unshift({
                    'code': '',
                    'name': ''
                });
            }
            if (!!journal){
                journal.unshift({
                    'id':'',
                    'name':'',
                });
            }
            var employeData = [
                {
                    'employe_name': hrPayslip.employee_id[1],
                    'salari': accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator)
                }
            ];

            var modalAdvancement = QWeb.render('EiruPayslipAddAdvancement',{
                employeData: employeData,
                salaryRule: salaryRule,
                journal: self.accountJournal
            });
            $('.openerp_webclient_container').after(modalAdvancement);
            $('.expired-account-modal').modal();

            /* Variable */
            var salaryRule = $('.expired-account-modal').find('.salary-rule');
            var details = $('.expired-account-modal').find('.advancement-details');
            var ammountInput = $('.expired-account-modal').find('.advancement-amount');
            var addAdvancement = $('.expired-account-modal').find('.add-advancement');
            var journalSelected = $('.expired-account-modal').find('.journal-selected');
            var statementSelected = $('.expired-account-modal').find('.statement-selected');

            /* Type Operation */
            salaryRule.change(function() {
                $('.expired-account-modal').find('.is-advancement').css('display','none');
                $('.expired-account-modal').find('.statement-open').css('display','none');
                statementSelected.empty();
                if (salaryRule.val() === 'ADL')
                    $('.expired-account-modal').find('.is-advancement').css('display','flex');
            });
            /*Journal Selected */
            journalSelected.change(function(e) {
                statementSelected.empty();
                $('.expired-account-modal').find('.statement-open').css('display','none');
                if (!!journalSelected.val() && !!self.eiruAccountBankUtatementUtility.length && !!self.statementConfig.length) {
                    if (self.statementConfig[0].import_statement_payslip === 'manual_import') {
                        var statement = self.getStatementeJournal(parseInt(journalSelected.val()));
                        if (!!statement.length) {
                            $('.expired-account-modal').find('.statement-open').css('display','flex');
                            statementSelected.append('<option value=""></option>');
                            _.each(statement, function(item) {
                                statementSelected.append('<option value="' + item.id + '">' + item.name+" - "+moment(item.date).format("DD-MM-YYYY")+ '</option>');
                            });
                        }
                    }
                }
            });
            /* Imputn amount */
            ammountInput.keyup(function() {
                amount_Adl = parseInt(accounting.unformat( ammountInput.val(),','));
                ammountInput.val(accounting.formatMoney((amount_Adl), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
            });
            /* button Guardar */
            addAdvancement.click(function(e){
                var amount = parseInt(accounting.unformat(ammountInput.val(),','));
                /* Type Operacion */
                if (!salaryRule.val()) {
                    openerp.web.notification.do_warn("Atención","Seleccione el tipo de operación.");
                    salaryRule.css('border-color','red');
                    salaryRule.focus();
                    return;
                }
                salaryRule.css('border-color','#ccc');

                /* amount */
                if (amount <= 0) {
                    openerp.web.notification.do_warn("Atención","El importe de la operación no debe ser  meno o igual 0 (cero).");
                    ammountInput.css('border-color','red');
                    ammountInput.focus();
                    return;
                }
                if (amount > payslipLine.amount && salaryRule.val() === "ADL"){
                    openerp.web.notification.do_warn("Atención","El importe del adelanto no puede superar el sueldo neto,\n Importe permitido "+ accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    ammountInput.css('border-color','red');
                    ammountInput.focus();
                    return;
                }
                ammountInput.css('border-color','#ccc');

                if (salaryRule.val() === "ADL") {
                    amount = (amount * -1);
                    /* Journal */
                    if (!journalSelected.val()){
                        openerp.web.notification.do_warn("Atención","Seleccione el método de pago.");
                        journalSelected.css('border-color','red');
                        journalSelected.focus();
                        return;
                    }
                    journalSelected.css('border-color','#ccc');
                    /* statement */
                    if (!!self.eiruAccountBankUtatementUtility.length && !!self.statementConfig.length) {
                        if (self.statementConfig[0].import_statement_payslip === 'manual_import') {
                            var statement = self.getStatementeJournal(parseInt(journalSelected.val()));
                            if (!!statement.length) {
                                if (!statementSelected.val()){
                                    openerp.web.notification.do_warn("Atención","Seleccione una caja para continuar.");
                                    statementSelected.css('border-color','red');
                                    statementSelected.focus();
                                    return;
                                }
                                statementSelected.css('border-color','#ccc');
                            }
                        }
                    }
                }
                /* Detalles */
                if (!details.val()) {
                    openerp.web.notification.do_warn("Atención","Defina una descripción para la operación.");
                    details.css('border-color','red');
                    details.focus();
                    return;
                }
                details.css('border-color','#ccc');

                values = {
                    'id': parseInt(self.id),
                    'salaryRule': salaryRule.val(),
                    'details': details.val(),
                    'amount': amount,
                    'journal': parseInt(journalSelected.val()),
                    'statementId': !!statementSelected.val() ? parseInt(statementSelected.val()) : '',
                    'statementConfigId': !!self.statementConfig.length ? self.statementConfig[0].id : '',
                };

                self.createPayslipInput(values).then(function(resultsPayslip){
                    return resultsPayslip;
                }).then(function(resultsPayslip){
                    self.removeModal(e);
                    defer.resolve(resultsPayslip);
                });

                return defer;
            });
            /* Close modal */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            return defer;
        },
        /* Crear Adelanto - comisiones */
        createPayslipInput: function(values) {
            var payslip = new openerp.web.Model('hr.payslip');
            return payslip.call('create_payslip_input',[values],{
                context: new openerp.web.CompoundContext()
            });
        },

        /***********************************************************************************
        Recalcular Nominas
          ____                _            _       _         ____                 _ _
         |  _ \ ___  ___ __ _| | ___ _   _| | __ _| |_ ___  |  _ \ __ _ _   _ ___| (_)_ __
         | |_) / _ \/ __/ _` | |/ __| | | | |/ _` | __/ _ \ | |_) / _` | | | / __| | | '_ \
         |  _ <  __/ (_| (_| | | (__| |_| | | (_| | ||  __/ |  __/ (_| | |_| \__ \ | | |_) |
         |_| \_\___|\___\__,_|_|\___|\__,_|_|\__,_|\__\___| |_|   \__,_|\__, |___/_|_| .__/
                                                                        |___/        |_|
        ************************************************************************************/
        fetchRecomputeSheet: function() {
            var self = this;
            self.$el.find('.refresh-advancement').attr("disabled", true);
            self.recomputeSheet().then(function(results) {
                return results;
            }).then(function() {
                self.$el.find('.refresh-advancement').removeAttr("disabled");
                self.reloadLine();
            });
        },

        /****************************************************************************
        Editar/Borrar Comisión
          _   _  ____      ____                          _         _
         | | | ||  _ \    / ___|___  _ __ ___  _ __ ___ (_)___ ___(_) ___  _ __  ___
         | | | || | | |  | |   / _ \| '_ ` _ \| '_ ` _ \| / __/ __| |/ _ \| '_ \/ __|
         | |_| || |_| |  | |__| (_) | | | | | | | | | | | \__ \__ \ | (_) | | | \__ \
         \___(_)____(_)  \____\___/|_| |_| |_|_| |_| |_|_|___/___/_|\___/|_| |_|___/
        ****************************************************************************/
        /* Description: Funcion  Inicial Modify/Unlink Faltas*/
        fetchModifyAdvancement: function() {
            var self = this;
            self.fetchPayslipInput().then(function(payslipInput) {
                return payslipInput;
            }).then(function(payslipInput) {
                self.payslipInput = payslipInput;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.joinInputSalari();
            }).then(function(inputSalari) {
                self.inputSalari = inputSalari;
                return self.fetchPayslipLine();
            }).then(function(payslipLine) {
                self.payslipLine =payslipLine;
                return self.fetchPayslip();
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.showModifyAdvancement();
            }).then(function() {
                return self.destroyObjects();
            });
        },
        /* Description: COnsultar Payslip Input (hr.payslip.input)*/
        fetchPayslipInput: function() {
            var self = this;
            var fields = ['id','name', 'code', 'amount','create_date'];
            var domain = [['payslip_id', '=', self.id]];
            var hrPayslipInput = new openerp.web.Model('hr.payslip.input');
            return hrPayslipInput.query(fields).filter(domain).all();
         },
         getpayslipInputUpdate: function(codes) {
            var self = this;
            return _.filter(self.payslipInput, function(item) {
                return _.contains(codes, item.code)
             //     return item.code === code;
            });
         },
        /* Description: Unir payslip_input con salary_rule*/
        joinInputSalari: function() {
            var self = this;
            var defer = $.Deferred();
            var inputSalari = [];
            var rule;
            // var payslipInput = self.getpayslipInput('CMS');
            // var types = ['CMS','HORA_EXTRA']
            var payslipInput = self.getpayslipInputUpdate(['CMS','HORA_EXTRA']);

            _.each(payslipInput, function(item) {
                rule = self.getSalaryRule(item.code).shift();
                if (!rule){
                    rule = {};
                    rule.name= item.code;
                }
                var amount = item.amount;

                inputSalari.push(
                    {
                        'id': item.id,
                        'name': item.name,
                        'code': item.code,
                        'amount': amount,
                        'input_name': rule.name
                    }
                );
            });
            defer.resolve(inputSalari);
            return defer;
         },
        /* Description : Filtar Salary_rule por code*/
        getSalaryRule: function(code) {
            var self = this;
             return _.filter(self.salaryRule, function(filter) {
                 return filter.code === code;
             });
         },
        /* Description: Modal para la Modificacion de Adelanto y faltas*/
        showModifyAdvancement: function() {
            var self = this;
            var defer = $.Deferred();
            var row_modify;
            var payslipLine = self.payslipLine.shift();
            var hrPayslip = self.hrPayslip.shift();
            var company = self.resCompany.shift();
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();
            var amountSelect = 0;
            var amount_Adl = 0;

            if (self.inputSalari.length === 0) {
                openerp.web.notification.do_warn("Atención","No existe registro  para modificar");
                return;
            }
            var employeData = [{
                    employe_name: hrPayslip.employee_id[1],
                    salari: accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator)
            }];
            var inputSalari = [];
            _.each(self.inputSalari, function(item) {
                inputSalari.push(
                    {
                        'id': item.id,
                        'name': item.name,
                        'code': item.code,
                        'amount': accounting.formatMoney(item.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                        'input_name': item.input_name
                    }
                )
            });
            var modalModifyAdvancement = QWeb.render('EiruPayslipModifyAdvancement', {
                inputData: inputSalari,
                employeData: employeData
            });
            $('.openerp_webclient_container').after(modalModifyAdvancement);
            $('.expired-account-modal').modal();

            var descript_input = $('.expired-account-modal').find('.advancement-details-modify');
            var amount_input = $('.expired-account-modal').find('.advancement-amount-modify');
            var buttonUpdate = $('.expired-account-modal').find('.modify-advancement');
            var unlinkAdvancement = $('.expired-account-modal').find('.unlink-advancement');
            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            buttonUpdate.attr("disabled", true);
            /* Salir*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve('salir');
                self.removeModal(e);
            });
            /* Seleccionar  fila */
            tableRow.click(function (e) {
                row_modify = $(e.target);
                if (($(e.target).index() === 5) || ($(e.target).index() === 0))
                    return;

                tableRow.removeClass('table-row-select');
                $(e.target).closest('tr').addClass('table-row-select');
                /* Cargar Campo Description y importe */
                descript_input.val(($(e.target).closest('tr').children()[3].textContent).trim());
                amountSelect = parseInt(accounting.unformat($(e.target).closest('tr').children()[4].textContent ,',' ));
                amount_input.val(accounting.formatMoney((amountSelect), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                // Actualizar el Id de elemento seleccionado
                self.row_id_select = parseInt($(e.target).closest('tr').children()[0].textContent);
                self.row_code_select = ($(e.target).closest('tr').children()[1].textContent).trim();
                // Habilitar botón modificar
                buttonUpdate.removeAttr("disabled");
                descript_input.focus();
            });
            /* Click botón Modificar */
            buttonUpdate.click(function() {
                var amount = parseInt(accounting.unformat(amount_input.val(),','));
                if (!descript_input.val()) {
                   openerp.web.notification.do_warn("Atención","Definir un motivo de la falta .");
                   descript_input.css('border-color','red');
                   descript_input.focus();
                   return;
                }
                descript_input.css('border-color','#ccc');
                if (amount <= 0) {
                    openerp.web.notification.do_warn("Atención","Días no trabajado, debe ser mayor que 0.");
                    amount_input.css('border-color','red');
                    amount_input.focus();
                    return;
                }
                var neto = accounting.unformat($('.expired-account-modal').find('.number').val(), ',');

                if (amount > (neto + amountSelect) && self.row_code_select === 'ADL') {
                    openerp.web.notification.do_warn("Atención","El importe del adelanto no puede superar el sueldo neto.\n Importe permitido "+accounting.formatMoney(neto + amountSelect, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    amount_input.css('border-color','red');
                    amount_input.focus();
                    return;
                }
                    amount_input.css('border-color','#ccc');
                /* Actualizar Adelanto / comision */
                self.writePayslipAdvancement(descript_input.val(), amount ).then(function(results){
                    return results;
                }).then(function() {
                    return self.recomputeSheet();
                }).then(function() {
                    return self.reloadLine();
                }).then(function() {
                    return self.fetchPayslipLine();
                }).then(function(payslipLine) {
                    self.payslipLine = payslipLine;
                    payslipLine = payslipLine.shift();
                    $('.expired-account-modal').find('.number').val(accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    defer.resolve(payslipLine);
                });
                row_modify.closest('tr').children()[3].textContent = descript_input.val();
                row_modify.closest('tr').children()[4].textContent =  accounting.formatMoney(amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator);

                descript_input.val("");
                amount_input.val(0);
                amountSelect = 0;
                buttonUpdate.attr("disabled", true);
           });
           /* Click boton Unlink/ Eliminar */
           unlinkAdvancement.click(function(e) {
                var unlink_row = parseInt($(e.target).closest('td').closest('tr').children()[0].textContent);
                var unlink_code =$(e.target).closest('td').closest('tr').children()[1].textContent;
                var unlink_amount = parseInt(accounting.unformat($(e.target).closest('tr').children()[4].textContent ,',' ));
                var neto = accounting.unformat($('.expired-account-modal').find('.number').val(), ',');

                if (unlink_amount > neto && unlink_code === 'CMS'){
                    openerp.web.notification.do_warn("Atención"," No podes eliminar una comisión con el  el importe mayor al sueldo neto.\n Sueldo neto actual "+accounting.formatMoney(neto, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    return;
                }

                self.unlinkPayslipAdvancement(unlink_row).then(function(results) {
                    return results;
                }).then(function() {
                    return self.recomputeSheet();
                }).then(function() {
                    return self.reloadLine();
                }).then(function() {
                    return self.fetchPayslipLine();
                }).then(function(payslipLine) {
                    self.payslipLine = payslipLine;
                    payslipLine = payslipLine.shift();
                    $('.expired-account-modal').find('.number').val(accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    defer.resolve(payslipLine);
                });

                $(e.target).closest('td').closest('tr').remove();
           });
           /* Keyup */
           amount_input.keyup(function() {
               amount_Adl = parseInt(accounting.unformat(amount_input.val(), ','));
               amount_input.val(accounting.formatMoney((amount_Adl), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
           });
            return defer;
        },
        /* Description: Funcion para Actualizar Adlanto / comision*/
        writePayslipAdvancement: function(description, amount_input) {
            var self = this;
            var defer = $.Deferred();
            var payslip = new openerp.web.Model('hr.payslip')
            var amount = amount_input;
            if (self.row_code_select === "ADL")
                amount = (amount_input * -1);

            payslip.call('write_payslip_input', [
                {
                    'id': self.id,
                    'input_id': self.row_id_select,
                    'descript_input': description,
                    'amount_input': amount
                }
            ], {
                context : new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        /* Description: Eliminar Adelanto /comision*/
        unlinkPayslipAdvancement: function(input_id) {
            var self = this;
            var defer = $.Deferred();
            var  payslip = new openerp.web.Model('hr.payslip');
            payslip.call('unlink_payslip_input',[{
                'id': self.id,
                'input_id': input_id
            }], {
                context: new openerp.web.CompoundContext()
            }).then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*********************************************************************************************************
        Imprimir adelanto y comisión de funcionario
             _       _                                                                _         _
            / \   __| |_   ____ _ _ __   ___ ___  ___    ___ ___  _ __ ___  _ __ ___ (_)___ ___(_) ___  _ __  ___
           / _ \ / _` \ \ / / _` | '_ \ / __/ _ \/ __|  / __/ _ \| '_ ` _ \| '_ ` _ \| / __/ __| |/ _ \| '_ \/ __|
          / ___ \ (_| |\ V / (_| | | | | (_|  __/\__ \ | (_| (_) | | | | | | | | | | | \__ \__ \ | (_) | | | \__ \
         /_/   \_\__,_| \_/ \__,_|_| |_|\___\___||___/  \___\___/|_| |_| |_|_| |_| |_|_|___/___/_|\___/|_| |_|___/
        **********************************************************************************************************/
        /* Description : Metodo Inicial de imprecion */
        fetchPrintAdvancement: function(type, title) {
            var self = this;
            self.fetchPayslip().then(function(hrPayslip) {
                return hrPayslip;
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchPayslipInput();
            }).then(function(payslipInput) {
                self.payslipInput = payslipInput;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.fetchResUser();
            }).then(function(resUser){
                self.resUser = resUser;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.showPrintAdvancement(type, title);
            });
        },
        /* Consultar Usuario (res.User) */
        fetchResUser: function() {
            var self = this;
            var resUser = new openerp.web.Model('res.users');
            return resUser.query(['name']).filter([['active', '=', true],['id', '=', self.uid]]).all();
        },
        /* Filtar Adelantos */
        getpayslipInput: function(code) {
            var self = this;
            return _.filter(self.payslipInput, function(item) {
                return item.code === code;
            });

        },
        /* Modal Selected print advancement */
        showPrintAdvancement: function(type, title) {
            var self = this;
            var defer = $.Deferred();
            var payslipInput = self.getpayslipInput(type);

            if (payslipInput.length === 0){
                openerp.web.notification.do_warn("Atención","El funcionario no cuenta con "+title+" registrado");
                return;
            }
            var inputBody = [];
            var inputSelect = [];
            var salaryRule;
            var company = self.resCompany[0];
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();

            _.each(payslipInput, function(input) {
                salaryRule = self.getSalaryRule(input.code).shift();
                if (!salaryRule){
                    salaryRule ={};
                    salaryRule.name="N/A";
                }
                var ammount = input.amount;
                if (ammount < 0)
                    ammount = -1* ammount;

                inputBody.push({
                    id: input.id,
                    code_name :  salaryRule.name,
                    code: input.code,
                    input_name: input.name,
                    amount_input: accounting.formatNumber((ammount), currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                    amount: (ammount),
                    date: moment(input.create_date).format('DD/MM/YYYY')
                });
            });

            var titleData = [
                {
                    title: "Impresión de "+title
                }
            ];
            var modalModifyAdvancement = QWeb.render('EiruPayslipPrintAdvancement', {
                advancementList: inputBody,
                modalTitle: titleData
            });
            $('.openerp_webclient_container').after(modalModifyAdvancement);
            $('.expired-account-modal').modal();

            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            var printAdvancement = $('.expired-account-modal').find('.print-advancement-selected')
            /* Salir*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve('salir');
                self.removeModal(e);
            });

            printAdvancement.click(function(e){
                self.jsPdfPrintAdvancement(inputSelect, type, title)
            })

            tableRow.click(function(e){
                if ($(e.target).index() !== 0)
                        return;

                idRow = parseInt(($(e.target).closest('tr').children()[0].textContent).trim());
                if (e.target.checked === true){
                    inputSelect.push(idRow)
                } else {
                    var indexRow = undefined;
                    _.each(inputSelect, function(input, index){
                        if (input === idRow) {
                            indexRow = index;
                        }
                    });
                    inputSelect.splice(indexRow,1);
                }
            });
            return defer;
        },
        /* Generar la impresion de Adelanto */
        jsPdfPrintAdvancement: function(inputSelect, type, titlePDF) {
            var self = this;
            var payslipInput = self.getpayslipInput(type);

            if (payslipInput.length === 0){
                openerp.web.notification.do_warn("Atención","El funcionario no cuenta con "+titlePDF+" registrado");
                return;
            }

            var inputBody = [];
            var inputHead = [
                {
                    title : 'Tipo de operación',
                    dataKey : 'code_name'
                },
                {
                    title : 'Descripción',
                    dataKey : 'input_name'
                },
                {
                    title : 'Importe',
                    dataKey : 'amount_input'
                },
                {
                    title : 'Fecha de operación',
                    dataKey : 'date'
                },
            ];
            var salaryRule;
            var company = self.resCompany[0];
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();

            if (!!inputSelect.length){
                payslipInput =  _.filter(payslipInput, function(input){
                    return _.contains(inputSelect, input.id);
                });
            }

            _.each(payslipInput, function(input) {
                salaryRule = self.getSalaryRule(input.code).shift();
                if (!salaryRule){
                    salaryRule ={};
                    salaryRule.name="N/A";
                }
                var ammount = input.amount
                if (ammount < 0)
                    ammount = -1* ammount;

                inputBody.push({
                    code_name :  salaryRule.name,
                    input_name: input.name,
                    amount_input: accounting.formatNumber((ammount), currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                    amount: (ammount),
                    date: moment(input.create_date).format('DD/MM/YYYY')
                });
            });
            /* sumar los importe*/
            var total = _.reduce(_.map(inputBody, function(map) {
                return map.amount;
            }),function(memo, num){
                return memo + num;
            }, 0);

            inputBody.push({
                code_name :  "",
                input_name: 'Total' ,
                amount_input: accounting.formatNumber(total, currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                amount: total,
                date: ""
            });
            self.drawPDF(inputHead, inputBody, total, currency, titlePDF);
        },
        /* Generar el pdf*/
        drawPDF: function(inputHead, inputBody, total, currency, titlePDF) {
            var self = this;
            var hrPayslip = self.hrPayslip[0];
            var resUser = self.resUser[0];
            var pdfDoc = new jsPDF();
            var title =titlePDF.toUpperCase();
            /* titulo */
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(18);
            pdfDoc.text(105, 20, "RECIBO DE "+title, null, null, 'center');
            /* Subtitulos*/
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(12);
            pdfDoc.text(20, 30, "Funcionario: ");
            pdfDoc.text(20, 40, "Referencia: ");
            pdfDoc.text(120, 40, "Periodo: ");
            /* Detalles */
            pdfDoc.setFontType('normal');
            pdfDoc.setFontSize(12);
            pdfDoc.text(50, 30, hrPayslip.employee_id[1]);
            pdfDoc.text(50, 40, hrPayslip.number);
            pdfDoc.text(150, 40, moment(hrPayslip.date_from).format('DD/MM/YYYY')+" - "+moment(hrPayslip.date_to).format('DD/MM/YYYY'));
            /* Tabla */
            pdfDoc.autoTable(inputHead, inputBody, {
                margin: {
                    top: 50,
                    horizontal: 7
                },
                styles: { overflow: 'linebreak', fontSize: 10, columnWidth: 'wrap'},
                columnStyles: {
                    code_name: {columnWidth: 35},
                    input_name: {columnWidth: 'auto'},
                    amount_input: {columnWidth: 30, halign:'right'},
                    date: {columnWidth: 40, halign:'center'},
                },
            });
            var first = pdfDoc.autoTable.previous;
            var fila = first.finalY;
            var moneda = self.getNameCurrency(currency.name);
            /*Final de la pagina*/
            fila = fila + 20;
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(12);
            pdfDoc.text(10, fila, "TOTAL EN LETRAS ");

            pdfDoc.setFontType('normal');
            pdfDoc.setFontSize(10);
            var text =moneda+": "+openerp.web.num2word(total);
            pdfDoc.text(50, fila, pdfDoc.splitTextToSize(text, 150),null, null, null);

            fila = fila + 20;
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(10);
            pdfDoc.text(10, fila, "Firma ......................................");
            pdfDoc.text(150, fila, "Firma ......................................");

            fila = fila + 5;
            pdfDoc.text(10, fila,resUser.name);
            pdfDoc.text(150, fila, hrPayslip.employee_id[1] );
            /* Guardar */
            var pdfTitle ='RECIBO DE '+title+' de'+hrPayslip.employee_id[1]+'.pdf';
            pdfDoc.save(pdfTitle.toUpperCase());

        },
        /* Obtener el nombre de la moneda */
        getNameCurrency: function(code) {
            var moneda = "";
            if (code === 'PYG') {
                moneda ="GUARANÍES";
            }
            if (code === 'USD') {
                moneda ="DÓLARES AMERICANOS";
            }
            return moneda;
        },

        /***********************************************************************************
         Exportar los adelanto en Registro de caja
          _____                       _     ____  _        _                            _
         | ____|_  ___ __   ___  _ __| |_  / ___|| |_ __ _| |_ ___ _ __ ___   ___ _ __ | |_
         |  _| \ \/ / '_ \ / _ \| '__| __| \___ \| __/ _` | __/ _ \ '_ ` _ \ / _ \ '_ \| __|
         | |___ >  <| |_) | (_) | |  | |_   ___) | || (_| | ||  __/ | | | | |  __/ | | | |_
         |_____/_/\_\ .__/ \___/|_|   \__| |____/ \__\__,_|\__\___|_| |_| |_|\___|_| |_|\__|
                    |_|
         **********************************************************************************/
        /* Description : Metodo Inicial de Exportar adelanto en caja*/
        fetchExportCash: function() {
            var self = this;
            self.fetchPayslipInput().then(function(payslipInput) {
                return payslipInput;
            }).then(function(payslipInput) {
                self.payslipInput = payslipInput;
                return self.fetchJournal();
            }).then(function(accountJournal) {
                self.accountJournal = accountJournal;
                return self.fetchStatementLine();
            }).then(function(statementLine) {
                self.statementLine = statementLine;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.fetchVerifyModule('eiru_account_bank_statement_utility');
            }).then(function(eiruAccountBankUtatementUtility) {
                self.eiruAccountBankUtatementUtility = eiruAccountBankUtatementUtility;
                return self.fetchStatementConfig();
            }).then(function(statementConfig) {
                self.statementConfig = statementConfig;
                return self.fetchStatementAvailable();
            }).then(function(statementAvailable) {
                self.statementAvailable = statementAvailable;
                return self.joinInputAdvancement();
            });
        },
        /* Consultar Lineas de Cajas */
        fetchStatementLine: function() {
            var statementLine = new openerp.web.Model('account.bank.statement.line');
            return statementLine.query(['name', 'note', 'ref']).filter([['ref','=', 'ADL']]).all();
        },
        /* Filtar los adelanto que no Exista en caja */
        joinInputAdvancement: function() {
            var self = this;
            var company = self.resCompany.shift();
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();
            var payslipInput = self.getAdvancementNotInBox();
            var InputPayslip = [];
            _.each(payslipInput, function(item) {
                InputPayslip.push({
                    'id': item.id,
                    'name': item.name,
                    'amount': accounting.formatMoney((-1 * item.amount), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator)
                });
            })
            self.showModalAdvancementExportCash(InputPayslip);
        },
        /* Filtra los adelanto que no están en caja */
        getAdvancementNotInBox: function() {
            var self = this;
            var payslipInput = self.getpayslipInput('ADL');

            var id_input = _.map(self.statementLine, function(map) {
                return parseInt(map.note);
            });
            return _.filter(payslipInput, function(filter) {
                return !_.contains(id_input, filter.id);
            });
        },
        /* Modal Exportar adelanto en caja*/
        showModalAdvancementExportCash: function(payslipInput){
            var self = this;
            var row_export;
            var journal = self.accountJournal;

            if (!!journal) {
                journal.unshift({
                    'id': '',
                    'name': ''
                });
            }

            if (payslipInput.length === 0) {
                openerp.web.notification.do_warn("Atención","No existe adelanto para importar en caja");
                return;
            }

            var modalAdvancementExportCash = QWeb.render('EiruAdvancementExportCash', {
                inputAdvancement: payslipInput,
                journal: journal
            });

            $('.openerp_webclient_container').after(modalAdvancementExportCash);
            $('.expired-account-modal').modal();

            /* Salir*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                self.removeModal(e);
            });

            /* Variable */
            var advancement_details = $('.expired-account-modal').find('.advancement-details');
            var advancement_amount = $('.expired-account-modal').find('.advancement-amount');
            var current_journal = $('.expired-account-modal').find('.advancement-journal');
            var advancementStatement = $('.expired-account-modal').find('.advancement-statement');
            /* bottom*/
            var advancement_export = $('.expired-account-modal').find('.advancement-export');

            /* Table */
            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');

            // Deshabilitar Campos
            current_journal.attr("disabled", true);
            advancement_export.attr("disabled", true);

            /* Seleccionar  fila */
            tableRow.click(function (e) {
                row_export = $(e.target);
                tableRow.removeClass('table-row-select');
                $(e.target).closest('tr').addClass('table-row-select');
                /* Cargar Campo Description y importe */
                advancement_details.val(($(e.target).closest('tr').children()[1].textContent).trim());
                advancement_amount.val(($(e.target).closest('tr').children()[2].textContent).trim());
                // Actualizar el Id de elemento seleccionado
                self.row_id_select = parseInt($(e.target).closest('tr').children()[0].textContent);
                // Habilitar Campos
                current_journal.removeAttr("disabled");
                advancement_export.removeAttr("disabled");
                /* Limpiar */
                current_journal.val('');
                advancementStatement.empty();
                current_journal.focus();
            });

            /* Journal Selected */
            current_journal.change(function(e) {
                $('.expired-account-modal').find('.statement-open').css('display','none');
                advancementStatement.empty();

                if (!!current_journal.val() && !!self.eiruAccountBankUtatementUtility.length && !!self.statementConfig.length && !!self.statementAvailable.length) {
                    var statement = self.getStatementeJournal(parseInt(current_journal.val()));
                    if (!!statement.length && self.statementConfig[0].import_statement_payslip === 'manual_import') {
                        $('.expired-account-modal').find('.statement-open').css('display','flex');
                        advancementStatement.append('<option value=""></option>');
                        _.each(statement, function(item) {
                            advancementStatement.append('<option value="' + item.id + '">' + item.name+" - "+moment(item.date).format("DD-MM-YYYY")+ '</option>');
                        });
                    }
                }
            });
            // clic en botón exportar
            advancement_export.click(function() {
                /* Journal Selected */
                if (!current_journal.val()) {
                    openerp.web.notification.do_warn("Atención","Tiene que seleccionar el método de pago para continuar.");
                    current_journal.focus();
                    current_journal.css('border-color','red');
                    return;
                }
                current_journal.css('border-color','#ccc');

                var statement = self.getStatementeJournal(parseInt(current_journal.val()));
                if (!!statement.length && !!self.eiruAccountBankUtatementUtility.length && !!self.statementConfig.length && !!self.statementAvailable.length) {
                    if (self.statementConfig[0].import_statement_payslip === 'manual_import' && !advancementStatement.val()) {
                        openerp.web.notification.do_warn("Atención","Tiene que seleccionar una caja para continuar.");
                        advancementStatement.focus();
                        advancementStatement.css('border-color','red');
                        return;
                    }
                    advancementStatement.css('border-color','#ccc');
                }

                self.bankStatementImport(self.row_id_select, parseInt(current_journal.val()), parseInt(advancementStatement.val())).then(function(results){
                    return results;
                }).then(function() {

                    row_export.closest('td').closest('tr').remove();
                    current_journal.attr("disabled", true);
                    advancement_export.attr("disabled", true);
                    current_journal.val('');
                    advancementStatement.empty();
                    advancement_details.val('');
                    advancement_amount.val('0');

                    row_export = "";
                });
            });
        },
        /* bank_statement_import */
        bankStatementImport: function(imputId, journalid, statementId) {
            var self = this;
            var payslip = new openerp.web.Model('hr.payslip');
            return payslip.call('bank_statement_import',[
                {
                    'payslipId': self.id,
                    'imputId': imputId,
                    'journalid': journalid,
                    'statementId': statementId
                }
            ],{
                    context: new openerp.web.CompoundContext()
            });
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'hr.payslip')
                    return;

                if (this.$el.find('.oe_form_sheet.oe_form_sheet_width').closest('.modal-content.openerp').length !== 0)
                    return;

                openerp.parentInstance = this;
                if (openerp.widgetInstanceAdvancement) {
                    openerp.widgetInstanceAdvancement.updateIdAdvancement(record.id);
                }

                if (this.$el.find('.payslip-add-advancement').length !== 0 )
                    return;

                openerp.widgetInstanceAdvancement = new openerp.PayslipAdvancement(this);

                var elemento = this.$el.find('.oe_notebook_page');
                elemento = elemento.find('.payslip-utility-add-advancement');

                openerp.widgetInstanceAdvancement.appendTo(elemento);
                openerp.widgetInstanceAdvancement.updateIdAdvancement(record.id);
            }
        });
    }
})();
